/// <reference types="node" />
import { Socket } from 'net';
import { microMTAMessage } from './message';
import { microMTAOptions } from './options';
export declare class microMTAConnection {
    private socket;
    private options;
    private onMessage;
    private onError;
    private onRejected;
    private buffer;
    private secure;
    private open;
    private greeted;
    private isAcceptingData;
    private recipients;
    private sender?;
    private isAuthenticating?;
    private authenticationUsername?;
    private authenticationPassword?;
    private authorizationIdentity?;
    /**
     * Connection state, can be used to store authentication data.
     */
    state: any;
    isAuthenticated: boolean;
    constructor(socket: Socket, options: microMTAOptions, onMessage: (message: microMTAMessage) => void, onError: (error: Error) => void, onRejected: (sender: string, recipients: string[]) => void);
    get isOpen(): boolean;
    private get supportedAuthenticationMethods();
    private get extensions();
    close(): void;
    reply(code: number, message?: string): void;
    private get greeting();
    private get extendedGreeting();
    private addListeners;
    private starttls;
    private handleData;
    private handleMessage;
    private handleAuthentication;
    private handleCommand;
}
