"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.microMTAConnection = void 0;
var tls_1 = require("tls");
var base64_js_1 = require("base64-js");
var util_1 = require("util");
var commands_1 = require("./smtp/commands");
var SMTPReply = require("./smtp/replies");
var ending = '\r\n';
var dataEnding = '\r\n.\r\n';
var defaultSize = 1000000;
var authLoginUsername = 'VXNlcm5hbWU6';
var authLoginPassword = 'UGFzc3dvcmQ6';
var textDecoder = new util_1.TextDecoder('utf-8');
var base64Decode = function (input) {
    if (!input) {
        return '';
    }
    try {
        return textDecoder.decode(base64_js_1.toByteArray(input));
    }
    catch (_a) {
        return '';
    }
};
var microMTAConnection = /** @class */ (function () {
    function microMTAConnection(socket, options, onMessage, onError, onRejected) {
        this.socket = socket;
        this.options = options;
        this.onMessage = onMessage;
        this.onError = onError;
        this.onRejected = onRejected;
        this.buffer = '';
        this.secure = false;
        this.open = false;
        this.greeted = false;
        this.isAcceptingData = false;
        this.recipients = [];
        this.isAuthenticated = false;
        this.socket.setEncoding('utf8');
        this.open = true;
        if (this.socket instanceof tls_1.TLSSocket) {
            this.secure = this.socket.encrypted;
        }
        // Welcome message.
        this.reply(220, this.options.hostname + ' ESMTP microMTA');
        this.addListeners(socket);
    }
    Object.defineProperty(microMTAConnection.prototype, "isOpen", {
        get: function () {
            return this.open;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(microMTAConnection.prototype, "supportedAuthenticationMethods", {
        get: function () {
            if (!this.options.authenticate) {
                return [];
            }
            return ['PLAIN', 'LOGIN'];
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(microMTAConnection.prototype, "extensions", {
        get: function () {
            var _a;
            var extensions = ['SMTPUTF8', 'PIPELINING', '8BITMIME'];
            if (!this.secure && this.options.secureContextOptions) {
                extensions.push('STARTTLS');
            }
            if (this.options.authenticate) {
                extensions.push('AUTH ' + this.supportedAuthenticationMethods.join(' '));
            }
            extensions.push('SIZE ' + ((_a = this.options.size) !== null && _a !== void 0 ? _a : defaultSize));
            return extensions;
        },
        enumerable: false,
        configurable: true
    });
    microMTAConnection.prototype.close = function () {
        this.socket.destroy();
        this.open = false;
    };
    microMTAConnection.prototype.reply = function (code, message) {
        if (!message) {
            this.socket.write(code + ending);
            return;
        }
        if (message.includes('\n')) {
            var lines = message.split('\n');
            for (var i = 0; i < lines.length; i++) {
                if (i === lines.length - 1) {
                    this.socket.write(code + ' ' + lines[i] + ending);
                }
                else {
                    this.socket.write(code + '-' + lines[i] + ending);
                }
            }
        }
        else {
            this.socket.write(code + ' ' + message + ending);
        }
        // 5xx errors result in an ended connection.
        if (code >= 500) {
            this.close();
        }
    };
    Object.defineProperty(microMTAConnection.prototype, "greeting", {
        get: function () {
            return this.options.hostname + ', greeting accepted.';
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(microMTAConnection.prototype, "extendedGreeting", {
        get: function () {
            return this.greeting + '\n' + this.extensions.join('\n');
        },
        enumerable: false,
        configurable: true
    });
    microMTAConnection.prototype.addListeners = function (socket) {
        var _this = this;
        socket.on('error', function (err) { return _this.onError(err); });
        socket.on('data', function (data) { return _this.handleData(data); });
        socket.on('close', function () { return (_this.open = false); });
        socket.on('end', function () { return (_this.open = false); });
    };
    microMTAConnection.prototype.starttls = function () {
        var _this = this;
        if (!this.options.secureContextOptions || this.secure) {
            return;
        }
        this.greeted = false;
        this.socket.removeAllListeners('error');
        this.socket.removeAllListeners('data');
        this.socket.removeAllListeners('close');
        this.socket.removeAllListeners('end');
        var secureContext = tls_1.createSecureContext(this.options.secureContextOptions);
        var tlsSocket = new tls_1.TLSSocket(this.socket, {
            secureContext: secureContext,
            rejectUnauthorized: false,
            isServer: true,
        });
        tlsSocket.setEncoding('utf8');
        this.socket = tlsSocket;
        // secure event needs to be used here instead of secureConnect.
        tlsSocket.on('secure', function () {
            _this.secure = true;
            _this.addListeners(tlsSocket);
        });
    };
    microMTAConnection.prototype.handleData = function (data) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var string, commands, i, args, command;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        string = data.toString();
                        if (!(!this.isAcceptingData && string.includes(ending))) return [3 /*break*/, 6];
                        commands = string.split(ending);
                        commands[0] = this.buffer + commands[0];
                        i = 0;
                        _b.label = 1;
                    case 1:
                        if (!(i < commands.length - 1)) return [3 /*break*/, 5];
                        if (!this.isAuthenticating) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.handleAuthentication(commands[i].split(' '))];
                    case 2:
                        _b.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        args = commands[i].split(' ');
                        command = args.splice(0, 1)[0];
                        this.handleCommand(command.toUpperCase(), args);
                        _b.label = 4;
                    case 4:
                        i++;
                        return [3 /*break*/, 1];
                    case 5:
                        // Store the incomplete command (or '') as the new buffer.
                        this.buffer = commands[commands.length - 1];
                        return [3 /*break*/, 7];
                    case 6:
                        this.buffer += string;
                        if (this.isAcceptingData) {
                            if (this.buffer.length > ((_a = this.options.size) !== null && _a !== void 0 ? _a : defaultSize)) {
                                this.buffer = '';
                                this.reply.apply(this, __spread(SMTPReply.MAXIMUM_SIZE_EXCEEDED));
                            }
                            // If a DATA message was sent, store all the
                            // incoming contents awaiting an ending.
                            if (this.buffer.includes(dataEnding)) {
                                this.handleMessage();
                            }
                        }
                        _b.label = 7;
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    microMTAConnection.prototype.handleMessage = function () {
        if (this.sender) {
            var message = this.buffer;
            // Remove last 5 characters (ending indicator).
            message = message.substring(0, this.buffer.length - 5);
            // Undo dot stuffing.
            message = message
                .split('\r\n')
                .map(function (line) { return (line.startsWith('..') ? line.substring(1) : line); })
                .join('\r\n');
            this.onMessage({
                recipients: this.recipients,
                sender: this.sender,
                message: message,
            });
            this.reply.apply(this, __spread(SMTPReply.OK));
        }
        else {
            this.reply.apply(this, __spread(SMTPReply.BAD_SEQUENCE));
        }
        this.buffer = '';
        this.isAcceptingData = false;
    };
    microMTAConnection.prototype.handleAuthentication = function (args, isInitialCommand) {
        if (isInitialCommand === void 0) { isInitialCommand = false; }
        return __awaiter(this, void 0, void 0, function () {
            var isComplete, data, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.isAuthenticating) {
                            this.reply.apply(this, __spread(SMTPReply.BAD_SEQUENCE));
                            return [2 /*return*/];
                        }
                        if (!this.options.authenticate) {
                            return [2 /*return*/];
                        }
                        isComplete = false;
                        switch (this.isAuthenticating) {
                            case 'PLAIN':
                                if (typeof args[0] === 'string') {
                                    data = base64Decode(args[0]).split('\0');
                                    if (data.length === 3) {
                                        this.authorizationIdentity = data[0];
                                        data.shift();
                                    }
                                    this.authenticationUsername = data[0];
                                    this.authenticationPassword = data[1];
                                    isComplete = true;
                                }
                                else if (!isInitialCommand) {
                                    isComplete = true;
                                }
                                else {
                                    this.reply(334);
                                }
                                break;
                            case 'LOGIN':
                                if (isInitialCommand) {
                                    this.reply(334, authLoginUsername);
                                }
                                else if (!this.authenticationUsername) {
                                    this.authenticationUsername = base64Decode(args[0]);
                                    this.reply(334, authLoginPassword);
                                }
                                else {
                                    this.authenticationPassword = base64Decode(args[0]);
                                    isComplete = true;
                                }
                                break;
                        }
                        if (!(isComplete &&
                            this.authenticationPassword &&
                            this.authenticationUsername)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.options.authenticate(this, this.authenticationUsername, this.authenticationPassword, this.authorizationIdentity)];
                    case 1:
                        result = _a.sent();
                        this.isAuthenticating = undefined;
                        this.isAuthenticated = result;
                        if (result) {
                            this.reply.apply(this, __spread(SMTPReply.AUTHENTICATION_SUCCESSFUL));
                        }
                        else {
                            this.reply.apply(this, __spread(SMTPReply.BAD_USERNAME_OR_PASSWORD));
                        }
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    microMTAConnection.prototype.handleCommand = function (command, args) {
        var e_1, _a;
        var _b;
        switch (command) {
            case commands_1.SMTPCommand.QUIT:
                // QUIT
                this.reply.apply(this, __spread(SMTPReply.BYE));
                this.close();
                return;
            case commands_1.SMTPCommand.NOOP:
                this.reply.apply(this, __spread(SMTPReply.OK));
                return;
        }
        if (!this.greeted) {
            switch (command) {
                case commands_1.SMTPCommand.HELO:
                    // HELO hostname
                    this.reply(250, this.greeting);
                    this.greeted = true;
                    break;
                case commands_1.SMTPCommand.EHLO:
                    // EHLO hostname
                    this.reply(250, this.extendedGreeting);
                    this.greeted = true;
                    break;
                default:
                    this.reply.apply(this, __spread(SMTPReply.BAD_SEQUENCE));
            }
            return;
        }
        switch (command) {
            case commands_1.SMTPCommand.HELO:
            case commands_1.SMTPCommand.EHLO:
                this.reply.apply(this, __spread(SMTPReply.BAD_SEQUENCE));
                break;
            case commands_1.SMTPCommand.STARTTLS:
                if (!this.options.secureContextOptions) {
                    this.reply.apply(this, __spread(SMTPReply.NOT_IMPLEMENTED));
                    break;
                }
                if (this.secure) {
                    this.reply.apply(this, __spread(SMTPReply.BAD_SEQUENCE));
                    break;
                }
                this.reply.apply(this, __spread(SMTPReply.TLS_GO_AHEAD));
                this.starttls();
                break;
            case commands_1.SMTPCommand.MAIL:
                // MAIL FROM:<user@example.com>
                if (args.length > 0 &&
                    args[0].toUpperCase().startsWith('FROM:<') &&
                    args[0].endsWith('>')) {
                    var size = 0;
                    if (args.length > 1) {
                        try {
                            for (var args_1 = __values(args), args_1_1 = args_1.next(); !args_1_1.done; args_1_1 = args_1.next()) {
                                var arg = args_1_1.value;
                                if (arg.toUpperCase().startsWith('SIZE=')) {
                                    size = parseInt(arg.substring(5));
                                }
                            }
                        }
                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                        finally {
                            try {
                                if (args_1_1 && !args_1_1.done && (_a = args_1.return)) _a.call(args_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                        }
                    }
                    var sender = args[0].substring(6, args[0].length - 1);
                    if (size && size > ((_b = this.options.size) !== null && _b !== void 0 ? _b : defaultSize)) {
                        this.reply.apply(this, __spread(SMTPReply.MAXIMUM_SIZE_EXCEEDED));
                        this.onRejected(sender, this.recipients);
                        break;
                    }
                    this.sender = sender;
                    this.reply.apply(this, __spread(SMTPReply.OK));
                }
                else {
                    this.reply.apply(this, __spread(SMTPReply.SYNTAX_ERROR_ARGUMENT));
                }
                break;
            case commands_1.SMTPCommand.RCPT:
                // RCPT TO:<user@example.com>
                if (args.length > 0 &&
                    args[0].toUpperCase().startsWith('TO:<') &&
                    args[0].endsWith('>')) {
                    this.recipients.push(args[0].substring(4, args[0].length - 1));
                    this.reply.apply(this, __spread(SMTPReply.OK));
                }
                else {
                    this.reply.apply(this, __spread(SMTPReply.SYNTAX_ERROR_ARGUMENT));
                }
                break;
            case commands_1.SMTPCommand.DATA:
                // DATA
                if (this.recipients.length > 0 && this.sender) {
                    this.reply.apply(this, __spread(SMTPReply.START_MAIL_INPUT));
                    this.isAcceptingData = true;
                }
                else {
                    this.reply.apply(this, __spread(SMTPReply.BAD_SEQUENCE));
                }
                break;
            case commands_1.SMTPCommand.AUTH:
                if (!this.supportedAuthenticationMethods.includes(args[0])) {
                    this.reply.apply(this, __spread(SMTPReply.NOT_IMPLEMENTED_ARGUMENT));
                    break;
                }
                this.isAuthenticating = args[0];
                this.handleAuthentication(args.slice(1), true);
                break;
            case commands_1.SMTPCommand.RSET:
                this.recipients = [];
                this.sender = undefined;
                this.reply.apply(this, __spread(SMTPReply.OK));
                break;
            default:
                this.reply.apply(this, __spread(SMTPReply.NOT_IMPLEMENTED));
        }
    };
    return microMTAConnection;
}());
exports.microMTAConnection = microMTAConnection;
